/*
 * Copyright (c) 1995 Brian A. Lantz
 * All rights reserved.
 */

#ifndef lint
char copyright[] =
"CBSD - Version "VERSION"\nCopyright (c) 1995 Brian A. Lantz. All rights reserved.\n";
#endif /* not lint */


#include "cbs.h"
#ifdef linux
#include <pwd.h>
#include <unistd.h>
#endif

#define	ENTRIES	50


void fatal(char const *msg);


void
fatal(char const *msg)
{
	fprintf(stderr, "cbsd: %s: %s\r\n", msg, strerror(errno));
	exit(1);
}


int
main(void)
{
register FILE *fp;
register int ch;
register char *lp;
int p[2];
char **ap, *av[ENTRIES + 1], line[1024];

	if (!fgets(line, sizeof(line), stdin))
		exit(1);

	av[0] = strdup("callbook");
	for (lp = line, ap = &av[1]; ; )	{
		*ap = strtok(lp, " \t\r\n");
		if (!*ap)
			break;
		if (++ap == av + ENTRIES)
			break;
		lp = NULL;
	}

	if (pipe(p) < 0)
		fatal("pipe");

#ifdef linux
	{
		struct passwd *pw;

		if ((pw = getpwnam("nobody")) != NULL) {
			(void) setgid(pw->pw_gid);
			(void) setuid(pw->pw_uid);
		}
	}
#endif

	switch(fork())	{
		case 0:		(void)close(p[0]);
				if (p[1] != 1)	{
					(void)dup2(p[1], 1);
					(void)close(p[1]);
				}
				execv(_PATH_CALLBOOK, av);
				_exit(1);
		case -1:	fatal("fork");
	}

	(void)close(p[1]);
	if (!(fp = fdopen(p[0], "r")))
		fatal("fdopen");
	while ((ch = getc(fp)) != EOF)	{
		if (ch == '\n')
			putchar('\r');
		putchar(ch);
	}
	return(0);
}

